// $Id: CTree.cpp,v 1.7 2001/01/29 21:58:25 chinaski Exp $

// ------------------------------------------------------------------- //
// Autores: Diego Chaparro Gonzlez - dchaparro@acm.org                //
//          Jos Pelegrn Lpez - josepl@acm.org                       //
// Creado: 22/12/00                                                    //
// Prctica de Inteligencia Artificial.                                //
// ------------------------------------------------------------------- //

#include "CTree.hpp"

// ------------------------------------------------------------------- //
// CTREE                                                               //
// ------------------------------------------------------------------- //
CTree::CTree(void)
{
  arbol = 0;
}

// ------------------------------------------------------------------- //
// CTREE                                                               //
// ------------------------------------------------------------------- //
CTree::CTree(const CBinaryTree& bt)
{
  CNodoT* nodo = new CNodoT;
  CBinaryTree* expresion = new CBinaryTree(bt);
  list<CTree*> vacio;

  nodo->raiz = expresion;
  nodo->arboles = vacio;

  arbol = nodo;
}

// ------------------------------------------------------------------- //
// CTREE                                                               //
// ------------------------------------------------------------------- //
CTree::CTree(const CBinaryTree& bt,
	     list<CTree*> as)
{
  CNodoT* nodo = new CNodoT;
  CBinaryTree* expresion = new CBinaryTree(bt);
  
  nodo->raiz = expresion;
  nodo->arboles = as;

  arbol = nodo;
}

// ------------------------------------------------------------------- //
// BORRARARBOL                                                         //
// ------------------------------------------------------------------- //
void CTree::BorrarArbol(CNodoT* nodo)
{
  CNodoT* actual;
  if (nodo)
    actual = nodo;
  else
    actual = arbol;

  if (actual)
    {
      list<CTree*>::iterator i = actual->arboles.begin();
      list<CTree*>::iterator final = actual->arboles.end();
      CTree *aux = new CTree;
      while (i != final)
	{
	  aux = *i++;
	  BorrarArbol(aux->arbol);
	}
      delete actual;
    }
}

// ------------------------------------------------------------------- //
// INSERTAREXPRESION                                                   //
// ------------------------------------------------------------------- //
void CTree::InsertarExpresion(const CBinaryTree& a)
{
  if (arbol)
    {
      CBinaryTree* expresion = new CBinaryTree(a);      
      arbol->raiz = expresion;
    }
  else throw PunteroNuloEx();
}

// ------------------------------------------------------------------- //
// INSERTARARBOL                                                       //
// ------------------------------------------------------------------- //
void CTree::InsertarArbol(const CBinaryTree& a)
{
  if (arbol)
    {
      CTree* nuevo_arbol = new CTree(a);
      arbol->arboles.push_back(nuevo_arbol);
    }
  else throw PunteroNuloEx();
}
