// $Id: func.cpp,v 1.17 2001/01/30 03:18:18 dchaparro Exp $

// ------------------------------------------------------------------- //
// Autores: Diego Chaparro Gonzlez - dchaparro@acm.org                //
//          Jos Pelegrn Lpez - josepl@acm.org                       //
// Creado: 22/12/00                                                    //
// Prctica de Inteligencia Artificial.                                //
// ------------------------------------------------------------------- //

#include "func.hpp"

// ------------------------------------------------------------------- //
// M E T A                                                             //
// ------------------------------------------------------------------- //
bool Meta(const CBinaryTree& expresion,
	  const vector<int>& secuencia)
{
  u_int i = 0;             // Recorrido de la secuencia.
  bool correcto = true;    // Comprobamos la correccin.
  
  while (correcto && ((i++) < secuencia.size())) {
    correcto = ObtenerValor(expresion, i-1) == secuencia[i-1];
  } 
  return correcto;
}

// ------------------------------------------------------------------- //
// O B T E N E R V A L O R                                             //
// ------------------------------------------------------------------- //
u_int ObtenerValor(CBinaryTree expresion,
		   int i)
{

  
  int res = 0;
  
  if ((expresion.GetArbolDerecho()).EsVacio()) {
    switch (expresion.GetRaiz()) {
    case UNO: 
      res = 1;
      break;
    case N:
      res = i;
      break;
    default:
      cout << "ERROR: Cte errnea: " << expresion.GetRaiz() << endl;
    }
  } 
  else {
    switch (expresion.GetRaiz()) {
    case 2:
      res = ObtenerValor (expresion.GetArbolIzquierdo(), i ) +
	ObtenerValor (expresion.GetArbolDerecho(), i );
      break;
    case 3:
      res = ObtenerValor (expresion.GetArbolIzquierdo(), i ) *
	ObtenerValor (expresion.GetArbolDerecho(), i );
      break;
    case 4:
      res = ObtenerValor (expresion.GetArbolIzquierdo(), i ) -
	ObtenerValor (expresion.GetArbolDerecho(), i );
      break;
    case 5:
      int aux;
      aux = ObtenerValor (expresion.GetArbolDerecho(), i);
      if (aux) 
	res = ObtenerValor (expresion.GetArbolIzquierdo(), i ) / aux;
      else res = 30000;
      break;
    case 6:

      double izq, der, tot;
      izq = ObtenerValor (expresion.GetArbolIzquierdo(), i);
      der = ObtenerValor (expresion.GetArbolDerecho(), i);
      if (izq>0 && der>=0)
	{
	  tot = pow (izq, der);
	  if ((tot > -32766) && (tot < 32766) )
	    res = (int)pow((double)ObtenerValor (expresion.GetArbolIzquierdo(), i),
			   (double)ObtenerValor(expresion.GetArbolDerecho(), i));
	  else{
	    res = 30000;
	  }
	}
      else{
	res = 30000;
      }
      break;
    default:
      cout << "ERROR: Op errnea: " << expresion.GetRaiz() << endl;
    }
  }
  return res;
}

// ------------------------------------------------------------------- //
// E X P A N D I R                                                     //
// ------------------------------------------------------------------- //
long Expandir(CTree& Arbol)
{
  list<CTree*> hijos;
  CTree* aux = new CTree;
  hijos = Arbol.GetArboles();
  long res = 0;

  CBinaryTree arbolbin(N);

  if (hijos.size() == 0) {
    arbolbin = Arbol.GetRaiz();
    res = IntroducirRamas (Arbol);
  }
  else {
    list<CTree*>::iterator actual = hijos.begin();
    list<CTree*>::iterator final = hijos.end();
    while (actual != final){
      aux = *actual++;
      res = res + Expandir (*aux);
    }
  }
  return res;
}


// ------------------------------------------------------------------ //
// I N T R O D U C I R   R A M A S                                    //
// ------------------------------------------------------------------ //
 


long IntroducirRamas (CTree& Arbol)
{
  list<CBinaryTree> ListaArboles;
  CBinaryTree auxbin;
  long res=0;

  auxbin = Arbol.GetRaiz();
  BuscarArboles (auxbin, ListaArboles);

  list<CBinaryTree>::iterator actual = ListaArboles.begin();
  list<CBinaryTree>::iterator final = ListaArboles.end();
  while (actual != final) {
    res ++;
    Arbol.InsertarArbol ((*actual));
    actual++;
  } 
  return res;
}

// ------------------------------------------------------------------ //
// B U S C A R   A R B O L E S                                        //
// ------------------------------------------------------------------ //
void BuscarArboles (CBinaryTree& RamaBinActual, list<CBinaryTree>& Lista) 
{
  CBinaryTree auxbin;
  CBinaryTree copybin;
  list<CBinaryTree> Lista2;
  
  CTree arbol;
  copybin.Copiar (RamaBinActual);
  if ( (RamaBinActual.GetArbolIzquierdo()).EsVacio()) {
    for (int i=1; i<=5; i++){
      switch (i) {
      case 1: // SUMA
	RamaBinActual.InsertarRaiz (SUMA);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
 	 	
	RamaBinActual.InsertarRaiz (SUMA);
	RamaBinActual.InsertarIzquierda (UNO);
	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (SUMA);
	RamaBinActual.InsertarIzquierda (N);
	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	break;
      case 2: // RESTA
	RamaBinActual.InsertarRaiz (RESTA);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (RESTA);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);

	RamaBinActual.InsertarRaiz (RESTA);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (RESTA);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	break;
      case 3: // MULTIPLICACION
	RamaBinActual.InsertarRaiz (MULTIPLICACION);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (MULTIPLICACION);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);

	RamaBinActual.InsertarRaiz (MULTIPLICACION);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	break;
      case 4: // DIVISION
	RamaBinActual.InsertarRaiz (DIVISION);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (DIVISION);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);

	RamaBinActual.InsertarRaiz (DIVISION);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (DIVISION);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	break;

      case 5: //POTENCIA
	RamaBinActual.InsertarRaiz (POTENCIA);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (POTENCIA);
 	RamaBinActual.InsertarIzquierda (UNO);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);

	RamaBinActual.InsertarRaiz (POTENCIA);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (UNO);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	
	RamaBinActual.InsertarRaiz (POTENCIA);
 	RamaBinActual.InsertarIzquierda (N);
 	RamaBinActual.InsertarDerecha (N);
	auxbin.Copiar (RamaBinActual);
	Lista.push_back (auxbin);
	break;

      default:
	break;
      }
    }
    RamaBinActual = copybin;
  }
  else{
    copybin.Copiar (RamaBinActual);
    auxbin = (RamaBinActual.GetArbolIzquierdo());
    BuscarArboles (auxbin, Lista2);
    
    list<CBinaryTree>::iterator actual = Lista2.begin();
    list<CBinaryTree>::iterator final = Lista2.end();
    while (actual != final) {
      RamaBinActual.InsertarIzquierda (*actual);
      auxbin.Copiar (RamaBinActual);
      Lista.push_back (auxbin);
      actual++;
    } 
    RamaBinActual = copybin;
    
    Lista2.clear();
    auxbin = (RamaBinActual.GetArbolDerecho());
    BuscarArboles (auxbin, Lista2);
     
    actual = Lista2.begin();
    final = Lista2.end();
    while (actual != final) {
      RamaBinActual.InsertarDerecha (*actual);
      auxbin.Copiar (RamaBinActual);
      Lista.push_back (auxbin);
      actual++;
    } 
    RamaBinActual = copybin;
  }
}

// ------------------------------------------------------------------- //
// B  S Q U E D A   P R O F U N D I D A D   I T E R A T I V A         //
// ------------------------------------------------------------------- //
CBinaryTree BusquedaPI (vector<int>& secuencia)
{
  bool conseguido = false;
  CBinaryTree ArbolBin2;
  long n_arboles=1;
  
  CBinaryTree ArbolBin(N);
  
  CTree Arbol(ArbolBin);
  if ( Meta(ArbolBin, secuencia) ) {
    conseguido = true;
    ArbolBin2 = ArbolBin;
  }
  else {
    int n=0;
    while (!conseguido) {
      cout << "Expando nivel: " << ++n << endl;
      n_arboles = Expandir(Arbol);
      cout << n_arboles <<" arboles en nivel " << n << endl;
      ArbolBin2 = BuscarExpr (Arbol, secuencia);
      if (!ArbolBin2.EsVacio()) conseguido=true;
    }
  }

  return (ArbolBin2);
}

// ------------------------------------------------------------------- //
// B U S C A R   E X P R                                               //
// ------------------------------------------------------------------- //
CBinaryTree BuscarExpr (CTree& Arbol, const vector<int>& secuencia)
{
  list<CTree*> hijos;
  CBinaryTree AuxBT;
  bool encontrado = false;

  if (Arbol.EsVacio()) {
    if (Meta(Arbol.GetRaiz(), secuencia)) {
      AuxBT = Arbol.GetRaiz();
    }
  }
  else {
    if (Meta(Arbol.GetRaiz(), secuencia)) {
      AuxBT = Arbol.GetRaiz();
    }
    else {
      hijos = Arbol.GetArboles();
      list<CTree*>::iterator actual = hijos.begin();
      list<CTree*>::iterator final = hijos.end();
      while ((actual != final) && (!encontrado)){
	AuxBT = BuscarExpr (**actual, secuencia);
	if (!AuxBT.EsVacio()) {
	  encontrado = true;
	}
	actual++;
      }
    }
  }
  return AuxBT;
}


// ------------------------------------------------------------------- //
// R E P R E S E N T A R   E X P R                                     //
// ------------------------------------------------------------------- //
string RepresentarExpr (CBinaryTree arbol)
{
  string res = "";
  
  switch (arbol.GetRaiz()){
  case 0: 
    res = "1 ";
    break;
  case 1:
    res = "n ";
    break;
  case 2:
    res = "+ ";
    break;
  case 3:
    res = "* ";
    break;
  case 4:
    res = "- ";
    break;
  case 5:
    res = "/ ";
    break;
  case 6:
    res = "pot ";
    break;
  default:
    cout << " ERROR: Al representar expresin. Simb desconoc: ";
    cout << arbol.GetRaiz() << endl;
  }
  if (! ((arbol.GetArbolIzquierdo()).EsVacio()) ) {
    res = res + RepresentarExpr(arbol.GetArbolIzquierdo()) +
      RepresentarExpr(arbol.GetArbolDerecho());
  }
  return (res);
}
