// $Id: func.hpp,v 1.10 2001/01/29 21:58:25 chinaski Exp $

// ------------------------------------------------------------------- //
// Autores: Diego Chaparro Gonzlez - dchaparro@acm.org                //
//          Jos Pelegrn Lpez - josepl@acm.org                       //
// Creado: 22/12/00                                                    //
// Prctica de Inteligencia Artificial.                                //
// ------------------------------------------------------------------- //

#if !defined( _func_HPP_ )
#define _func_HPP_

#include <string>
#include <vector>
#include <math.h>
#include <values.h>
#include "CBinaryTree.hpp"
#include "CTree.hpp"

// ------------------------------------------------------------------- //
// M E T A                                                             //
// Precondiciones: ??                                                  //
// Postcondiciones: A partir de una expresin aritmtica y una         //
//                  secuencia, decide si esa expresin puede generar   //
//                  la secuencia.                                      //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //
bool Meta(const CBinaryTree& expresion,
	  const vector<int>& secuencia);

// ------------------------------------------------------------------- //
// E X P A N D I R                                                     //
// Precondiciones: ??                                                  //
// Postcondiciones: A partir de una expresin aritmtica y un entero,  //
//                  devuelve el resultado de aplicar la expresin      //
//                  sobre el valor.                                    //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //

u_int ObtenerValor(CBinaryTree expresion,
		   int i);

// ------------------------------------------------------------------- //
// B  S Q U E D A   P R O F U N D I D A D   I T E R A T I V A         //
// Precondiciones: ??                                                  //
// Postcondiciones: A partir de una secuencia de nmeros,  va          //
//                  expandiendo el rbol y devuelve la expresin       //
//                  que la genera                                      //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //
long Expandir(CBinaryTree& expresion);

// ------------------------------------------------------------------- //
// I N T R O D U C I R   R A M A S                                     //
// Precondiciones: ??                                                  //
// Postcondiciones: En una rama del rbol vaca introduce todas        //
//                  las posibles combinaciones de ctes y operads       //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //
long IntroducirRamas (CTree& Arbol);


// ------------------------------------------------------------------- //
// B U S C A R   A R B O L E S                                         //
// Precondiciones: ??                                                  //
// Postcondiciones: Obtiene una lista con todos lo posibles rboles    //
//                  creados a partir de uno, que contengan una         //
//                  constante ms                                      //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //
void BuscarArboles (CBinaryTree& RamaBinActual, list<CBinaryTree>& Lista);

// ------------------------------------------------------------------- //
// O B T E N E R V A L O R                                             //
// Precondiciones: ??                                                  //
// Postcondiciones: A partir de una expresin aritmtica y un entero,  //
//                  devuelve el resultado de aplicar la expresin      //
//                  sobre el valor.                                    //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //
CBinaryTree BusquedaPI (vector<int>& secuencia);


// ------------------------------------------------------------------- //
// B U S C A R   E X P R                                               //
// Precondiciones: ??                                                  //
// Postcondiciones: A partir de una secuencia de nmeros, busca        //
//                  en el rbol y devuelve la expresin que la         //
//                  genera                                             //
// Excepciones: ??                                                     //
// ------------------------------------------------------------------- //
CBinaryTree BuscarExpr (CTree& Arbol, const vector<int>& secuencia);

string RepresentarExpr (CBinaryTree arbol);


#endif // _func_HPP_
