// $Id: pCBinaryTree.cpp,v 1.7 2001/01/29 21:58:25 chinaski Exp $

// ------------------------------------------------------------------- //
// Autores: Diego Chaparro Gonzlez - dchaparro@acm.org                //
//          Jos Pelegrn Lpez - josepl@acm.org                       //
// Creado: 22/12/00                                                    //
// Prctica de Inteligencia Artificial.                                //
// ------------------------------------------------------------------- //

// ------------------------------------------------------------------- //
// Parmetros de entrada al programa principal                         //
// (Todava ninguno)
// ------------------------------------------------------------------- //

#include "CBinaryTree.hpp"
#include <iostream>
#include <stdlib.h>

#define PARAMETROS_ENTRADA_MAIN 1

// ------------------------------------------------------------------- //
// M A I N                                                             //
// ------------------------------------------------------------------- //
int main(int argc, char *argv[])
{
  if (argc != PARAMETROS_ENTRADA_MAIN)
    {
      cout<<"Parmetros incorrectos."<<endl;
      cout<<"Uso: "<<argv[0]<<endl;
      return EXIT_FAILURE;
    }
  
  try
    {      
      // Creamos la expresin "+".
      CBinaryTree suma(SUMA);
      cout<<((suma.EsVacio())?"VACIO":"NO VACIO")<<endl;
      cout<<suma.GetRaiz()<<" ";

      suma.InsertarIzquierda (UNO);
      suma.InsertarDerecha (N);

      CBinaryTree mult(MULTIPLICACION);
      mult.InsertarIzquierda(suma);
      mult.InsertarDerecha(suma);

      // Creamos la expresin "+ 1 1".
      suma.InsertarIzquierda(UNO);
      suma.InsertarDerecha(UNO);
      cout<<(suma.GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<(suma.GetArbolDerecho()).GetRaiz()<<endl;

      // Creamos la expresin "pot + 1 1 n"
      CBinaryTree exp(POTENCIA);
      exp.InsertarIzquierda(suma);
      exp.InsertarDerecha(N);
      cout<<exp.GetRaiz()<<" ";
      cout<<(exp.GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((exp.GetArbolIzquierdo()).GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((exp.GetArbolIzquierdo()).GetArbolDerecho()).GetRaiz()<<" ";
      cout<<(exp.GetArbolDerecho()).GetRaiz()<<" ";
      cout<<endl;
      CBinaryTree arbolaux = exp.GetArbolDerecho();
      cout<<arbolaux.GetRaiz()<<endl;
      exp.InsertarRaiz(MULTIPLICACION);
      cout<<exp.GetRaiz()<<" ";
      cout<<(exp.GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((exp.GetArbolIzquierdo()).GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((exp.GetArbolIzquierdo()).GetArbolDerecho()).GetRaiz()<<" ";
      cout<<(exp.GetArbolDerecho()).GetRaiz()<<endl;
      arbolaux.InsertarRaiz(UNO);
      cout<<arbolaux.GetRaiz()<<endl;

      // Prueba del operador copia.
      CBinaryTree copia_exp(exp);
      copia_exp.InsertarIzquierda(suma);
      copia_exp.InsertarDerecha(N);
      cout<<copia_exp.GetRaiz()<<" ";
      cout<<(copia_exp.GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((copia_exp.GetArbolIzquierdo()).GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((copia_exp.GetArbolIzquierdo()).GetArbolDerecho()).GetRaiz()<<" ";
      cout<<(copia_exp.GetArbolDerecho()).GetRaiz()<<" ";
      cout<<endl;

      // Prueba del operador asignacin.
      CBinaryTree asignacion_exp;
      {
	CBinaryTree copia2_exp(exp);
	asignacion_exp = copia2_exp;
      }
      cout<<copia_exp.GetRaiz()<<" ";
      cout<<(copia_exp.GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((copia_exp.GetArbolIzquierdo()).GetArbolIzquierdo()).GetRaiz()<<" ";
      cout<<((copia_exp.GetArbolIzquierdo()).GetArbolDerecho()).GetRaiz()<<" ";
      cout<<(copia_exp.GetArbolDerecho()).GetRaiz()<<" ";
      cout<<endl;

      // Grado de un arbol.
      CBinaryTree vacio;
      CBinaryTree n(N);
      cout<<vacio.Grado()<<endl;
      cout<<n.Grado()<<endl;
      cout<<suma.Grado()<<endl;
      cout<<exp.Grado()<<endl;

      // Prueba de borrar.
      mult.BorrarArbol();
      //n.BorrarArbol();
    }
  catch( PunteroNuloEx ex )
    {
      cerr<<ex.what()<<endl;
      return EXIT_FAILURE;
    }
      
  return EXIT_SUCCESS;
}

// RESULTS ---------------------------
// NO VACIO
// 2 0 0
// 6 2 0 0 1 
// 1
// 3 2 0 0 1
// 0
// 3 2 0 0 1 
// 3 2 0 0 1 
// 0
// 1
// 2
// 3
// RESULTS ---------------------------
