// $Id: pctree.cpp,v 1.5 2001/01/29 18:20:59 chinaski Exp $

// ------------------------------------------------------------------- //
// Autores: Diego Chaparro Gonzlez - dchaparro@acm.org                //
//          Jos Pelegrn Lpez - josepl@acm.org                       //
// Creado: 22/12/00                                                    //
// Prctica de Inteligencia Artificial.                                //
// ------------------------------------------------------------------- //

// ------------------------------------------------------------------- //
// Parmetros de entrada al programa principal                         //
// (Todava ninguno)
// ------------------------------------------------------------------- //

#include <iostream>
#include <stdlib.h>
#include "CTree.hpp"

#define PARAMETROS_ENTRADA_MAIN 1

// ------------------------------------------------------------------- //
// M A I N                                                             //
// ------------------------------------------------------------------- //
int main(int argc, char *argv[])
{
  if (argc != PARAMETROS_ENTRADA_MAIN)
    {
      cout<<"Parmetros incorrectos."<<endl;
      cout<<"Uso: "<<argv[0]<<endl;
      return EXIT_FAILURE;
    }
  
  try
    {  
      // Creamos el arbol con la expresin "n".
      CBinaryTree n(N);
      CTree nivel1(n);
      cout<<(nivel1.GetRaiz()).GetRaiz()<<endl;

      // Aumentamos el nivel con unas pocas expresiones.
      CBinaryTree suma(SUMA);
      suma.InsertarIzquierda(UNO);
      suma.InsertarDerecha(UNO);
      CTree *nivel2 = new CTree(suma);
      list<CTree*> expresiones;
      expresiones.push_back(nivel2);
      expresiones.push_back(nivel2);
      expresiones.push_back(nivel2);
      CTree otro_nivel2(suma, expresiones);
      list<CTree*> arboles_nivel2;
      arboles_nivel2 = otro_nivel2.GetArboles();
      cout<<arboles_nivel2.size()<<endl;
      list<CTree*>::iterator actual = arboles_nivel2.begin();
      list<CTree*>::iterator final = arboles_nivel2.end();
      CTree *aux = new CTree;
      while (actual != final)
	{
	  aux = *actual++;
	  cout<<(aux->GetRaiz()).GetRaiz()<<" ";
	}
      cout<<endl;

      // Cambiamos una expresin e insertamos un rbol.
      CBinaryTree uno(UNO);
      nivel1.InsertarExpresion(uno);
      cout<<(nivel1.GetRaiz()).GetRaiz()<<endl;
      nivel1.InsertarArbol(uno);
      list<CTree*> arboles_nivel1;
      arboles_nivel1 = nivel1.GetArboles();
      cout<<arboles_nivel1.size()<<endl;

      // Prueba de borrar().
      nivel1.BorrarArbol();
    }
  catch( PunteroNuloEx ex )
    {
      cerr<<ex.what()<<endl;
      return EXIT_FAILURE;
    }
      
  return EXIT_SUCCESS;
}

// RESULTS ---------------------------
// 1
// 3
// 2 2 2 
// 0
// 1
// RESULTS ---------------------------

